//------------------------------------------------------------------------------
//                        Utils
//------------------------------------------------------------------------------
var path = require('path')
var fs = require("fs");

class helpers {

    objectToAdif(qso){
      var rv = "";
      for (var key in qso){
        if ((key.startsWith("_")) || (key.endsWith("_")) || (qso[key].length == 0))
          continue;
        try {
        if (qso[key] !== null)
          rv+= "<" + key + ":" + qso[key].toString().trim().length + ">" + qso[key].toString().trim()
      } catch (e) { console.log(key, qso[key], e);}
      }
      rv += "<EOR>";
      return rv;
    }

    parseAdifLine(line){
      // Change how to handle the file content
      var qualityRegex = /\<\w*\:\d*(\:[A-Z])?\>(\w|\s|\d|\-|\+)*/g,
          matches,
          tokens = [];

      while (matches = qualityRegex.exec(line)) {
          tokens.push(matches[0]);
        }
      var qso = {}
      tokens.forEach((t)=>{
        var tmp = t.split(/[\<\>\:]+/)
        qso[tmp[1]] = tmp[tmp.length-1];
      })
      return qso
    }

    parseAdifFile(data){
      var list = []
      var isHeaderLine = true;
      data.split('\n').forEach((line,i)=>{
        if (!isHeaderLine)
        {
          var qso = this.parseAdifLine(line);

          if (Object.keys(qso).length === 0 && qso.constructor === Object)
            return;
          list.push(qso)
        }
        if (line.includes("<EOH>"))
          isHeaderLine = false;
      })
      return list;
    }
  }

  module.exports = new helpers()
